#!/usr/bin/perl -w 

sub usage(){
    print STDERR "Usage: $0 [-h <host>:<port>] [-j] [-m 'message']\n";
    print STDERR "-j :Sending a sequence of command for JIVE experiemnt\n";
    exit(1);
}

# use Exporter;
use IO::Socket;                   # IO::Socket ⥸塼Ȥ
use lib "$ENV{HOME}/prog/perl/module";


my @cmds= qw/"in2net=connect:192.42.120.66" "mode=ext:0xff:1" "play_rate=data:08" "net_protocol=UDP:3200000:10" "in2net=on"/;

my $cnt=0;
{
    usage() if(@ARGV <1);
    my $host = "localhost";
    my $port = 2630;
    my $jive=0;
    my $msg;
    while(@ARGV){
	my $opt = shift;
	if($opt =~/-h/){
	    usage() unless(@ARGV);
	    my @terms = split(/:/,shift);
	    $host = $terms[0];
	    $port = $terms[1] if(@terms >1);
	}elsif($opt =~/-j/){
	    $jive=1;
	}elsif($opt =~/-m/){
	    $msg=shift;
	}
    }

    my $remote = IO::Socket::INET->new(Proto    => "tcp",
				       PeerAddr => $host,
				       PeerPort => $port );
    
    if( ! $remote){	die "Could not connect to $host:$port \n";    }

    select($remote); $|=1; # stop buffering 
    select(STDIN); $|=1; # stop buffering 
    select(STDOUT); $|=1; # stop buffering 

    my $line;
    if($jive){
	while(@cmds){
	    my $cmd = shift(@cmds);
	    print STDOUT " cmd=$cmd\n";
	    &communicate($remote,"$cmd\n");
	}
    }elsif(defined($msg)){
	    print STDOUT " cmd=$msg\n";
	    &communicate($remote,"$msg\n");
    }else{
	while(<STDIN>){
	    $line = $_;
	    print STDOUT  $line;
	    &communicate($remote,$line);
	}
    }
   

}

sub communicate($$){
    my $socket = shift;
    my $line = shift;

    last unless(defined($socket));
    print $socket $line;
    last unless(defined($socket));
    
    my $res = <$socket>;
    next unless(defined($res));
    chomp($res);
    print STDERR "Res[$cnt]: $res\n" if(defined($res));
    $cnt++;
    
}
